/*
 *  Copyright (c) 2004 by Luis G. Lopez <llopez@cnba.uba.ar>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
* This is the main class.<p>
*
* Its provides a file filter for the log files.
*
* @author    <A HREF="mailto:llopez@cnba.uba.ar">Luis G. Lpez</A>, Argentina
* @version   0.1 (12 Abril 2004)
**/
public class FiltroLog extends FileFilter {

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        if (f.getName().endsWith(".LOG") 
			|| f.getName().endsWith(".log")
			|| f.getName().endsWith(".TXT")
			|| f.getName().endsWith(".txt")) {
            return true;
        }
        return false;
    }

    public String getDescription() {
        return "Archivos LOG (*.log, *.txt)";
    }
}