/*
 *  Copyright (c) 2004 by Luis G. Lopez <llopez@cnba.uba.ar>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;

/**
* This is the main class.<p>
*
* It shows an <i>About</i> window.
*
* @author    <A HREF="mailto:llopez@cnba.uba.ar">Luis G. Lpez</A>, Argentina
* @version   0.1 (12 Abril 2004)
**/
public class PanelLogo extends JPanel {

	private GridBagConstraints gridBagConstraints;
	private JLabel Linfo;
	private JLabel Licono;
	private ImageIcon logo;

	public PanelLogo () {
		setBorder(new TitledBorder(null, "", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 1, 12)));
		logo = new ImageIcon("logo.gif");
		Licono = new JLabel("http://www.astro.cnba.uba.ar", logo, JLabel.CENTER);
		Licono.setVerticalTextPosition(JLabel.BOTTOM);
		Licono.setHorizontalTextPosition(JLabel.CENTER);
		Linfo = new JLabel();
		Linfo.setText("<html><center>Este programa es gratuito y <i>open source</i><p>y fue desarrollado en el<p><b>Observatorio del<br>Colegio Nacional de<br>Buenos Aires</b></center></html>");
		
		setLayout(new GridBagLayout());

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
		gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(Licono, gridBagConstraints);
		
		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
		gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        add(Linfo, gridBagConstraints);
	}

	public void setTextLinfo(String texto) {
		Linfo.setText(texto);
	}
}