/*
 *  Copyright (c) 2004 by Luis G. Lopez <llopez@cnba.uba.ar>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

/**
* This is the main class.<p>
*
* @author    <A HREF="mailto:llopez@cnba.uba.ar">Luis G. Lpez</A>, Argentina
* @version   0.1 (12 Abril 2004)
**/
public class binarias extends JFrame implements ActionListener {
    
    /** Creates new form binarias, displaying the labels according to the language chosen
	*	by the user when he runs the application <p>
	*	
	*	@param Lenguaje Language chosen by the user. Default is <i>espaol</i>.
	*	
	*/
    public binarias(String Lenguaje) {
        initComponents(Lenguaje);
    }
    
    /** Exit the Application */
    private void exitForm(WindowEvent evt) {
        System.exit(0);
    }
    
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("F_I")) {
			jSpinnerFechaInicio.setValue(new Date());
		} 
		else if (e.getActionCommand().equals("F_F")) {
			jSpinnerFechaFin.setValue(new Date());
		}
		else if (e.getActionCommand().equals("A_C")) {
			if (!jTextFieldC.getText().equals("")) {
				lmC.addElement(jTextFieldC.getText());
				jListC.ensureIndexIsVisible(lmC.getSize()-1);
				jTextFieldC.setText("");
				jTextFieldC.requestFocus();
				calcularAP();
			}
		}
		else if (e.getActionCommand().equals("B_C")) {
			while (!jListC.isSelectionEmpty()) {
				lmC.remove(jListC.getMinSelectionIndex());
			}
			calcularAP();
			calcularRho();
		}
		else if (e.getActionCommand().equals("A_AP")) {
			if (!jTextFieldAP.getText().equals("")) {
				lmAP.addElement(jTextFieldAP.getText());
				jListAP.ensureIndexIsVisible(lmAP.getSize()-1);
				jTextFieldAP.setText("");
				jTextFieldAP.requestFocus();
				calcularAP();
				calcularRho();
			}
		}
		else if (e.getActionCommand().equals("B_AP")) {
			while (!jListAP.isSelectionEmpty()) {
				lmAP.remove(jListAP.getMinSelectionIndex());
			}
			calcularAP();
			calcularRho();
		}
		else if (e.getActionCommand().equals("M_D")) {
			if (!jTextFieldMinDiv.getText().equals("")) {
				calcularAP();
				calcularRho();
			}
		}
		else if (e.getActionCommand().equals("A_A")) {
			if (!jTextFieldA.getText().equals("")) {
				calcularRho();
			}
		}
		else if (e.getActionCommand().equals("A_T")) {
			if (!jTextFieldT.getText().equals("")) {
				lmT.addElement(jTextFieldT.getText());
				jListT.ensureIndexIsVisible(lmT.getSize()-1);
				jTextFieldT.setText("");
				jTextFieldT.requestFocus();
				calcularRho();
			}
		}
		else if (e.getActionCommand().equals("B_T")) {
			while (!jListT.isSelectionEmpty()) {
				lmT.remove(jListT.getMinSelectionIndex());
			}
			calcularRho();
		}
		else if (e.getActionCommand().equals("Es")) {
			if (!Lenguaje.equals("espaol")) {
				Lenguaje = "espaol";
				setLanguageLabels(Lenguaje);
			}
		}
		else if (e.getActionCommand().equals("En")) {
			if (!Lenguaje.equals("english")) {
				Lenguaje = "english";
				setLanguageLabels(Lenguaje);
			}
		}
		else if (e.getActionCommand().equals("A_D")) {
			JOptionPane.showMessageDialog(this,
			    plogo,
				jMenuA_D.getText(),
				JOptionPane.PLAIN_MESSAGE);
		}
		else if (e.getActionCommand().equals("G_L")) {
			FiltroLog fl = new FiltroLog();
            fc.addChoosableFileFilter(fl);
			int returnVal = fc.showSaveDialog(this);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				boolean error = false;
				File archivo = fc.getSelectedFile();
				if (archivo.exists()) {
					int n = JOptionPane.showConfirmDialog(null, 
							CuidadoEscribir, "Estrellas Binarias", JOptionPane.YES_NO_OPTION,
							JOptionPane.WARNING_MESSAGE);
					if (n != JOptionPane.OK_OPTION) {
						error = true;
					}
				}
				if (!error)	{
					String nombre = archivo.getPath();
					if (!nombre.endsWith(".log") && !nombre.endsWith(".log")) {
						nombre = nombre + ".log";
					}
					crearLog(nombre);
				}
			}
		}
		else if (e.getActionCommand().equals("S")) {
			System.exit(0);
		}
	}

	/** Calculates the Position Angle
	*/
	public void calcularAP() {
		if (lmAP.getSize() != 0 && lmC.getSize() != 0 && !jTextFieldMinDiv.getText().equals("")) {
			double minDiv = new Double(jTextFieldMinDiv.getText()).doubleValue(); 
				minDiv = minDiv / 2.0;
			valores = convertirAdouble(lmAP);
			promedioAP = et.getPromedio(valores);
			errAP = et.getErrAbs(valores);
				errAP = Math.max(errAP, minDiv);
			valores = convertirAdouble(lmC);
			promedioC = et.getPromedio(valores);
			errC = et.getErrAbs(valores);
				errC = Math.max(errC, minDiv);
			pAP = promedioAP-promedioC;
			while (pAP < 0) pAP += 360.0;
			jTextFieldAPm.setText(myFormatter.format(pAP));
			jTextFieldAPe.setText(myFormatter.format(errAP+errC));
		} else {
			jTextFieldAPm.setText("");
			jTextFieldAPe.setText("");
		}
	}

	/** Calculates the Angular Separation
	*/
	public void calcularRho() {
		if (lmAP.getSize() != 0 && lmC.getSize() != 0 && lmT.getSize() != 0 && !jTextFieldMinDiv.getText().equals("")) {
			double minDiv = new Double(jTextFieldMinDiv.getText()).doubleValue(); 
				minDiv = minDiv / 2.0;
			minDiv = minDiv * rad;
			valores = convertirAdouble(lmT);
			promedioT = et.getPromedio(valores);
			errT = et.getSigmaN_1(valores);
			A = Double.parseDouble(jTextFieldA.getText());
			A = A*rad;
			AP = (promedioAP-promedioC)*rad;
			double decg = Double.parseDouble(jSpinnerDecg.getValue().toString());
			double decm = Double.parseDouble(jSpinnerDecm.getValue().toString());
			double decs = Double.parseDouble(jSpinnerDecs.getValue().toString());
			declinacion = Math.abs(decg) + decm/60.0 + decs/3600.0;
				if (decg < 0)  declinacion = -declinacion;
			declinacion = declinacion*rad;
			promedioRho = 15.04 * promedioT * Math.cos(declinacion) * Math.cos(A) / Math.sin(AP - A);
			promedioRho = Math.abs(promedioRho);
			double derivT = 15.04 * Math.cos(declinacion) * Math.cos(A) / Math.sin(AP - A);
			double derivAP = 15.04 * promedioT * Math.cos(declinacion) * Math.cos(A) * Math.cos(AP - A) / Math.pow(Math.sin(AP - A),2);
			double derivA = 0;
			if (A != 0)	{
				derivA = 15.04 * promedioT * Math.cos(declinacion) * Math.cos(AP) / Math.pow(Math.sin(AP - A),2);
			}			
			errRho = Math.sqrt( Math.pow(derivT*errT,2) + Math.pow(derivAP*(errAP+errC)*rad,2) + Math.pow(derivA*minDiv,2) );
			jTextFieldRhom.setText(myFormatter.format(promedioRho));
			jTextFieldRhoe.setText(myFormatter.format(errRho));
			jTextFieldRhoer.setText(myFormatter.format(errRho/promedioRho*100));
		} else {
			jTextFieldRhom.setText("");
			jTextFieldRhoe.setText("");
			jTextFieldRhoer.setText("");
		}
	}

	/** Creates the log file (ascii), using the chosen language. <p>
	*	The default directory is <i>./logs</i>
	*
	*   @param archivo The name of the log file.
	*/
	public void crearLog(String archivo) {
		StringBuffer texto = new StringBuffer();
		texto.append(jLabelDesc.getText());
		texto.append("\n");
		texto.append(jTextAreaDesc.getText());
		texto.append("\n\n");
		texto.append(jLabelAR.getText());
		texto.append(jSpinnerARh.getValue()+
						"h "+
						jSpinnerARm.getValue()+
						"m "+
						jSpinnerARs.getValue()+
						"s"
		);
		texto.append("\n");
		texto.append(jLabelDEC.getText());
		texto.append(jSpinnerDecg.getValue()+
						" "+
						jSpinnerDecm.getValue()+
						"' "+
						jSpinnerDecs.getValue()+
						"\""
		);
		texto.append("\n");
		texto.append(jLabelEq.getText());
		texto.append(jTextFieldEq.getText());
		texto.append("\n\n");
		texto.append(jLabelObs.getText());
		texto.append("\n");
		texto.append(jTextFieldObs.getText());
		texto.append("\n\n");
		texto.append(jLabelInstr.getText());
		texto.append("\n");
		texto.append(jTextAreaInstr.getText());
		texto.append("\n\n");	
		
		texto.append(jLabelMinDiv.getText());
		texto.append("\n");
		texto.append(jTextFieldMinDiv.getText());
		texto.append("\n\n");	


		texto.append(jLabelFechaInicio.getText());
		texto.append(jSpinnerFechaInicio.getValue().toString());
		texto.append("\n");	
		texto.append(jLabelFechaFin.getText());
		texto.append(jSpinnerFechaFin.getValue().toString());
		texto.append("\n\n");	
		texto.append("-----"+ ((TitledBorder)Sur.getBorder()).getTitle() +"-----");	
		texto.append("\n");
		texto.append(jLabelAPm.getText());
		texto.append(jTextFieldAPm.getText());
		texto.append("\n");
		texto.append("\t");
		texto.append("error: ");
		texto.append(jTextFieldAPe.getText());
		texto.append("\n\n");
		texto.append(jLabelRho.getText());
		texto.append(jTextFieldRhom.getText());
		texto.append("\n");
		texto.append("\t");
		texto.append("error: ");
		texto.append(jTextFieldRhoe.getText());
		texto.append("\n");
		texto.append("\t");
		texto.append("error(%): ");
		texto.append(jTextFieldRhoer.getText());
		texto.append("\n\n");
		texto.append("-----"+ ((TitledBorder)jPanelCentro.getBorder()).getTitle() +"-----");	
		texto.append("\n");
		texto.append(jLabelC.getText());
		texto.append("\t\t");
		texto.append(jLabelAP.getText());
		texto.append("\t\t");
		texto.append(jLabelT.getText());
		texto.append("\n");
		int max = Math.max(lmC.getSize(), lmAP.getSize());
		max = Math.max(max, lmT.getSize());
		for (int i=0; i<max; i++ ) {
			if (i<lmC.getSize()) texto.append(lmC.get(i).toString());
				else texto.append(" ");
			texto.append("\t\t\t\t");
			if (i<lmAP.getSize()) texto.append(lmAP.get(i).toString());
				else texto.append(" ");
			texto.append("\t\t\t\t\t");
			if (i<lmT.getSize()) texto.append(lmT.get(i).toString());
				else texto.append(" ");
			texto.append("\n");
		}

		try {
            FileWriter out;
            out = new FileWriter(archivo, false);
			out.write(texto.toString());
            out.close();
		} catch (IOException ex) {
		}	
	}

	/**
	*	Converts a ListModel into a Vector of double values
	*
	*	@param dlm the ListModel to be converted
	*/
	public double [] convertirAdouble(DefaultListModel dlm) {
		int n = dlm.getSize();
		double [] v = new double [n];
		for (int i=0; i<n; i++ ) {
			v [i] = new Double(dlm.get(i).toString()).doubleValue();
		}
		return v;
	}

	/**
	*	Displays the labels of components according to the chosen language.
	*
	*	@param Lenguaje	Language chosen by user
	*/
	public void setLanguageLabels(String Lenguaje) {
		if (Lenguaje.equals("espaol")) {
			setTitle("Estrellas Binarias");
			fc.setDialogTitle("Guardar Log");
			jLabelDesc.setText("Descripci\u00f3n: ");
			jLabelAR.setText("A.R.:");
			jLabelDEC.setText("Dec.:");
			jLabelObs.setText("Observador/es:");
			jLabelInstr.setText("Instrumental:");
			jLabelFechaInicio.setText("Inicio:");
			jLabelFechaFin.setText("Fin:");
			jButtonF_I.setText("< Ahora");
			jButtonF_F.setText("< Ahora");
			jLabelEq.setText("Equinoccio:");
			jPanelCentro.setBorder(new TitledBorder(null, "Mediciones", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 1, 12)));
			jPanelAP.setBorder(new TitledBorder(null, "\u00c1ngulo de posici\u00f3n (AP)", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 3, 12)));
			jLabelC.setText("\u00c1ngulo Cero (C):");
			jButtonA_C.setText("Agregar  >");
			jButtonB_C.setText("Borrar seleccionados");
			jLabelAP.setText("\u00c1ngulo P:");
			jButtonA_AP.setText("Agregar >");
			jButtonB_AP.setText("Borrar seleccionados");
			jPanelRho.setBorder(new TitledBorder(null, "Separaci\u00f3n angular (rho)", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 3, 12)));
			jLabelA.setText("\u00c1ngulo auxiliar (A):");
			jLabelMinDiv.setText("Mnima divisin angular (grados):");
			jLabelT.setText("Tiempos cronometrados (segs):");
			jButtonA_T.setText("Agregar >");
			jButtonB_T.setText("Borrar selecionados");
			Sur.setBorder(new TitledBorder(null, "Resultados", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 1, 12)));
			jLabelAPm.setText("\u00c1ngulo de Posici\u00f3n (\u00ba):");
			jLabelAPe.setText("<html>err<sub>AP</sub>:</html>");
			jLabelAPer.setText("<html>err<sub>AP</sub>%:</html>");
			jLabelRho.setText("Separaci\u00f3n angular (\"):");
			jLabelRhoe.setText("<html>err<sub>rho</sub>:</html>");
			jLabelRhoer.setText("<html>err<sub>rho</sub>%:</html>");
			jMenuA.setText("Archivo");
			jMenuItemG_L.setText("Guardar Log...");
			jMenuA_D.setText("Acerca de...");
			jMenuItemS.setText("Salir");
			jMenuL.setText("Language");
			jMenuItemEs.setText("espaol");
			jMenuItemEn.setText("english");
			plogo.setTextLinfo("<html><center>Este programa es gratuito y <i>open source</i><p>y fue desarrollado en el<p><b>Observatorio del<br>Colegio Nacional de<br>Buenos Aires</b></center></html>");
			CuidadoEscribir = "El archivo elegido existe actualmente.\nDesea sobreescribirlo?";
		}
		else if (Lenguaje.equals("english"))	{
			setTitle("Estrellas Binarias");
			fc.setDialogTitle("Save Log");
			jLabelDesc.setText("Description: ");
			jLabelAR.setText("R.A.:");
			jLabelDEC.setText("Dec.:");
			jLabelObs.setText("Observer/s:");
			jLabelInstr.setText("Instrumental:");
			jLabelFechaInicio.setText("Beginning:");
			jLabelFechaFin.setText("End:");
			jButtonF_I.setText("< Now");
			jButtonF_F.setText("< Now");
			jLabelEq.setText("Epoch:");
			jPanelCentro.setBorder(new TitledBorder(null, "Measures", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 1, 12)));
			jPanelAP.setBorder(new TitledBorder(null, "Position Angle (PA)", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 3, 12)));
			jLabelC.setText("Zero Angle (C):");
			jButtonA_C.setText("Add  >");
			jButtonB_C.setText("Delete selected");
			jLabelAP.setText("Angle P:");
			jButtonA_AP.setText("Add >");
			jButtonB_AP.setText("Delete selected");
			jPanelRho.setBorder(new TitledBorder(null, "Angular separation (rho)", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 3, 12)));
			jLabelA.setText("Auxiliar Angle (A):");
			jLabelMinDiv.setText("Mimnimum angular division (degrees):");
			jLabelT.setText("Measures times (secs):");
			jButtonA_T.setText("Add >");
			jButtonB_T.setText("Delete selected");
			Sur.setBorder(new TitledBorder(null, "Results", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", 1, 12)));
			jLabelAPm.setText("Position Angle (\u00ba):");
			jLabelAPe.setText("<html>err<sub>PA</sub>:</html>");
			jLabelAPer.setText("<html>err<sub>PA</sub>%:</html>");
			jLabelRho.setText("Angular separation (\"):");
			jLabelRhoe.setText("<html>err<sub>rho</sub>:</html>");
			jLabelRhoer.setText("<html>err<sub>rho</sub>%:</html>");
			jMenuA.setText("File");
			jMenuItemG_L.setText("Save Log...");
			jMenuA_D.setText("About...");
			jMenuItemS.setText("Exit");
			jMenuL.setText("Language");
			jMenuItemEs.setText("espaol");
			jMenuItemEn.setText("english");
			plogo.setTextLinfo("<html><center>This program is freeware and open source<p>was developed in the<p><b>Observatorio del<br>Colegio Nacional de<br>Buenos Aires</b></center></html>");
			CuidadoEscribir = "The selected file already exists.\nDo you want to overwrite it?";
		}
	}

	public JFormattedTextField getTextField(JSpinner spinner) {
		JComponent editor = spinner.getEditor();
		if (editor instanceof JSpinner.DefaultEditor) {
			return ((JSpinner.DefaultEditor)editor).getTextField();
		} else {
			System.err.println("Unexpected editor type: "
                           + spinner.getEditor().getClass()
                           + " isn't a descendant of DefaultEditor");
	        return null;
		}
	}

    /**
     * @param args the command line arguments
	 *
	 *	The only useful parameter is the first argument; it defines the language chosen. Default is <i>espaol</i>. 
	 *	It can be changed latter with the menu bar.
     */
    public static void main(String args[]) {
		try {
			UIManager.setLookAndFeel(
				UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) { }

		String id = "espaol";
		if (args.length != 0) {
			if (args[0].equals("english")) id = "english";
		}

		new binarias(id).show();
    }
    
	/**
	*	Inits the GUI
	*
	*	@param lenguaje Language chosen by the user. Default is <i>espaol</i>.
	*/
	private void initComponents(String lenguaje) {
        GridBagConstraints gridBagConstraints;

        lmC = new DefaultListModel();
		lmAP = new DefaultListModel();
		lmT = new DefaultListModel();
		jScrollPaneC = new JScrollPane();
		jScrollPaneAP = new JScrollPane();
		jScrollPaneT = new JScrollPane();
		fc = new JFileChooser("../logs");
        jPanelNorte = new JPanel();
        jLabelDesc = new JLabel();
        jLabelAR = new JLabel();
        jLabelDEC = new JLabel();
        jSpinnerARh = new JSpinner(new SpinnerNumberModel(0, 0, 23, 1));
		ftf = getTextField(jSpinnerARh);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
		jSpinnerARm = new JSpinner(new SpinnerNumberModel(0, 0, 59, 1));
		ftf = getTextField(jSpinnerARm);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
		jSpinnerARs = new JSpinner(new SpinnerNumberModel(0.0, 0.0, 59.0, 1.0));
		ftf = getTextField(jSpinnerARs);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
		jSpinnerDecg = new JSpinner(new SpinnerNumberModel(0, -90, 90, 1));
		ftf = getTextField(jSpinnerDecg);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
		jSpinnerDecm = new JSpinner(new SpinnerNumberModel(0, 0, 59, 1));
		ftf = getTextField(jSpinnerDecm);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
        jSpinnerDecs = new JSpinner(new SpinnerNumberModel(0.0, 0.0, 59.0, 1.0));
		ftf = getTextField(jSpinnerDecs);
		if (ftf != null ) {
			ftf.setColumns(3);
			ftf.setHorizontalAlignment(JTextField.RIGHT);
		}
        jLabelObs = new JLabel();
        jTextFieldObs = new JTextField();
        jLabelInstr = new JLabel();
        jLabelFechaInicio = new JLabel();
		jLabelFechaFin = new JLabel();
        jSpinnerFechaInicio = new JSpinner(new SpinnerDateModel());
		jSpinnerFechaInicio.setEditor(new JSpinner.DateEditor(jSpinnerFechaInicio, "dd/MMMM/yyyy HH:mm"));
		jSpinnerFechaFin = new JSpinner(new SpinnerDateModel());
		jSpinnerFechaFin.setEditor(new JSpinner.DateEditor(jSpinnerFechaFin, "dd/MMMM/yyyy HH:mm"));
		jButtonF_I = new JButton();
			jButtonF_I.addActionListener(this);
			jButtonF_I.setActionCommand("F_I");
		jButtonF_F = new JButton();
			jButtonF_F.addActionListener(this);
			jButtonF_F.setActionCommand("F_F");
        jScrollPaneDesc = new JScrollPane();
        jTextAreaDesc = new JTextArea();
        jScrollPaneInstr = new JScrollPane();
        jTextAreaInstr = new JTextArea();
        jLabelEq = new JLabel();
        jTextFieldEq = new JTextField();
        jPanelCentro = new JPanel();
        jPanelAP = new JPanel();
        jLabelC = new JLabel();
        jTextFieldC = new JTextField();
			jTextFieldC.addActionListener(this);
			jTextFieldC.setActionCommand("A_C");
        jListC = new JList(lmC);
        jButtonA_C = new JButton();
			jButtonA_C.addActionListener(this);
			jButtonA_C.setActionCommand("A_C");
        jButtonB_C = new JButton();
			jButtonB_C.addActionListener(this);
			jButtonB_C.setActionCommand("B_C");
        jLabelAP = new JLabel();
        jLabel11 = new JLabel();
        jTextFieldAP = new JTextField();
			jTextFieldAP.addActionListener(this);
			jTextFieldAP.setActionCommand("A_AP");
        jButtonA_AP = new JButton();
			jButtonA_AP.addActionListener(this);
			jButtonA_AP.setActionCommand("A_AP");
        jListAP = new JList(lmAP);
        jButtonB_AP = new JButton();
			jButtonB_AP.addActionListener(this);
			jButtonB_AP.setActionCommand("B_AP");
        jPanelRho = new JPanel();
        jLabelA = new JLabel();
        jTextFieldA = new JTextField();
			jTextFieldA.addActionListener(this);
			jTextFieldA.setActionCommand("A_A");
		jLabelMinDiv = new JLabel();
		jTextFieldMinDiv = new JTextField();
			jTextFieldMinDiv.addActionListener(this);
			jTextFieldMinDiv.setActionCommand("M_D");
        jLabel12 = new JLabel();
        jLabelT = new JLabel();
        jTextFieldT = new JTextField();
			jTextFieldT.addActionListener(this);
			jTextFieldT.setActionCommand("A_T");
        jButtonA_T = new JButton();
			jButtonA_T.addActionListener(this);
			jButtonA_T.setActionCommand("A_T");
        jListT = new JList(lmT);
        jButtonB_T = new JButton();
			jButtonB_T.addActionListener(this);
			jButtonB_T.setActionCommand("B_T");
        Sur = new JPanel();
        jLabelAPm = new JLabel();
        jTextFieldAPm = new JTextField();
        jLabelAPe = new JLabel();
        jTextFieldAPe = new JTextField();
        jLabelAPer = new JLabel();
        jTextFieldAPer = new JTextField();
        jLabelRho = new JLabel();
        jTextFieldRhom = new JTextField();
        jLabelRhoe = new JLabel();
        jTextFieldRhoe = new JTextField();
        jLabelRhoer = new JLabel();
        jTextFieldRhoer = new JTextField();
        jMenuBar1 = new JMenuBar();
        jMenuA = new JMenu();
		jMenuA_D = new JMenuItem();
			jMenuA_D.setActionCommand("A_D");
			jMenuA_D.addActionListener(this);
        jMenuItemG_L = new JMenuItem();
			jMenuItemG_L.setActionCommand("G_L");
			jMenuItemG_L.addActionListener(this);
        jSeparator1 = new JSeparator();
        jMenuItemS = new JMenuItem();
			jMenuItemS.setActionCommand("S");
			jMenuItemS.addActionListener(this);
        jMenuL = new JMenu();
        jMenuItemEs = new JRadioButtonMenuItem();
			jMenuItemEs.setActionCommand("Es");
			jMenuItemEs.addActionListener(this);
		jMenuItemEn = new JRadioButtonMenuItem();
			jMenuItemEn.setActionCommand("En");
			jMenuItemEn.addActionListener(this);
		plogo = new PanelLogo();
		gLenguaje = new ButtonGroup();
		Lenguaje = lenguaje;
		et = new estadistica();
		myFormatter = new DecimalFormat("#####.##");
		
        fc.setDialogType(JFileChooser.SAVE_DIALOG);

        setFont(new Font("Abbess", 0, 10));
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanelNorte.setLayout(new GridBagLayout());

        jPanelNorte.setBorder(new BevelBorder(BevelBorder.RAISED));
        jLabelDesc.setHorizontalAlignment(SwingConstants.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        gridBagConstraints.anchor = GridBagConstraints.NORTHEAST;
        jPanelNorte.add(jLabelDesc, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jLabelAR, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jLabelDEC, gridBagConstraints);

        //jTextFieldAR.setPreferredSize(new Dimension(100, 20));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerARh, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 6;
			gridBagConstraints.gridy = 0;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel("h"), gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 0;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerARm, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 8;
			gridBagConstraints.gridy = 0;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel("m"), gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 0;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerARs, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 10;
			gridBagConstraints.gridy = 0;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel("s"), gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerDecg, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 6;
			gridBagConstraints.gridy = 1;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel(""), gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 1;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerDecm, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 8;
			gridBagConstraints.gridy = 1;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel("'"), gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 1;
		//gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerDecs, gridBagConstraints);
			gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 10;
			gridBagConstraints.gridy = 1;
			//gridBagConstraints.weightx = 0.3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.insets = new Insets(2, 2, 2, 2);
			jPanelNorte.add(new JLabel("\""), gridBagConstraints);


        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 1;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        gridBagConstraints.anchor = GridBagConstraints.EAST;
        gridBagConstraints.weighty = 0.5;
        jPanelNorte.add(jLabelObs, gridBagConstraints);

        jTextFieldObs.setHorizontalAlignment(JTextField.LEFT);
        jTextFieldObs.setPreferredSize(new Dimension(120, 20));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 2;
		gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 0.3;
        jPanelNorte.add(jTextFieldObs, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 1;
        gridBagConstraints.anchor = GridBagConstraints.CENTER;
		gridBagConstraints.insets = new Insets(2, 10, 2, 2);
        jPanelNorte.add(jLabelInstr, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = GridBagConstraints.EAST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jLabelFechaInicio, gridBagConstraints);
		
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = GridBagConstraints.EAST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jLabelFechaFin, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jButtonF_I, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
		gridBagConstraints.weightx = .5;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerFechaInicio, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jButtonF_F, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jSpinnerFechaFin, gridBagConstraints);

        jTextAreaDesc.setLineWrap(true);
        jTextAreaDesc.setWrapStyleWord(true);
        jTextAreaDesc.setMaximumSize(new Dimension(2147483647, 32));
        jTextAreaDesc.setMinimumSize(new Dimension(50, 16));
        jScrollPaneDesc.setViewportView(jTextAreaDesc);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.gridheight = 2;
		gridBagConstraints.weightx = 0.3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jScrollPaneDesc, gridBagConstraints);

        jScrollPaneInstr.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPaneInstr.setMaximumSize(new Dimension(32767, 32));
        jTextAreaInstr.setLineWrap(true);
        jTextAreaInstr.setWrapStyleWord(true);
		gridBagConstraints.weightx = 0.5;
        jTextAreaInstr.setMaximumSize(new Dimension(2147483647, 32));
        jScrollPaneInstr.setViewportView(jTextAreaInstr);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 9;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jScrollPaneInstr, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jLabelEq, gridBagConstraints);

        jTextFieldEq.setColumns(4);
        jTextFieldEq.setHorizontalAlignment(JTextField.RIGHT);
        jTextFieldEq.setText("2000.0");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
		gridBagConstraints.weightx = 0.2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelNorte.add(jTextFieldEq, gridBagConstraints);

        getContentPane().add(jPanelNorte, BorderLayout.NORTH);

        jPanelCentro.setLayout(new GridBagLayout());

        jPanelAP.setLayout(new GridBagLayout());

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jLabelC, gridBagConstraints);

        jTextFieldC.setColumns(10);
        jTextFieldC.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.weightx = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jTextFieldC, gridBagConstraints);

        
		//jListC.setMinimumSize(new Dimension(75, 100));
		//jListC.setPreferredSize(new Dimension(75, 100));
		jScrollPaneC.setViewportView(jListC);
		//jScrollPaneC.setPreferredSize(new Dimension(75, 50));
		jScrollPaneC.setMinimumSize(new Dimension(75, 1));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.5;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jScrollPaneC, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jButtonA_C, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
		gridBagConstraints.gridheight = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.SOUTH;
        //gridBagConstraints.weighty = 1.0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jButtonB_C, gridBagConstraints);

        jLabel11.setText("  ");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jLabel11, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jLabelAP, gridBagConstraints);

        jTextFieldAP.setColumns(10);
        jTextFieldAP.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
		gridBagConstraints.weightx = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jTextFieldAP, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jButtonA_AP, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabel12, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.gridwidth = 2;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabel12, gridBagConstraints);

        //jScrollPaneAP.setMinimumSize(new Dimension(75, 1));
		jScrollPaneAP.setViewportView(jListAP);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = .5;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jScrollPaneAP, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.SOUTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelAP.add(jButtonB_AP, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
		gridBagConstraints.gridheight = 2;
        jPanelCentro.add(jPanelAP, gridBagConstraints);

        jPanelRho.setLayout(new GridBagLayout());

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabelA, gridBagConstraints);

        jTextFieldA.setColumns(5);
        jTextFieldA.setHorizontalAlignment(JTextField.RIGHT);
        jTextFieldA.setText("0");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jTextFieldA, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabelMinDiv, gridBagConstraints);

        jTextFieldMinDiv.setColumns(5);
        jTextFieldMinDiv.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jTextFieldMinDiv, gridBagConstraints);

        jLabel12.setText(" ");
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabel12, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabelT, gridBagConstraints);

        jTextFieldT.setColumns(5);
        jTextFieldT.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
		gridBagConstraints.weightx = 0.5;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jTextFieldT, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jButtonA_T, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabel12, gridBagConstraints);

		gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jLabel12, gridBagConstraints);

		jScrollPaneT.setMinimumSize(new Dimension(75, 100));
        //jScrollPaneT.setMinimumSize(new Dimension(75, 1));
		jScrollPaneT.setViewportView(jListT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridheight = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jScrollPaneT, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = GridBagConstraints.SOUTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        jPanelRho.add(jButtonB_T, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
		gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = 1;
		gridBagConstraints.gridheight = 1;
		//gridBagConstraints.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints.weighty = 1.0;
        jPanelCentro.add(jPanelRho, gridBagConstraints);

        getContentPane().add(jPanelCentro, BorderLayout.CENTER);

        Sur.setLayout(new GridBagLayout());

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelAPm, gridBagConstraints);

        jTextFieldAPm.setColumns(10);
        jTextFieldAPm.setEditable(false);
        jTextFieldAPm.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldAPm, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelAPe, gridBagConstraints);

        jTextFieldAPe.setColumns(10);
        jTextFieldAPe.setEditable(false);
        jTextFieldAPe.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldAPe, gridBagConstraints);
/*
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelAPer, gridBagConstraints);

        jTextFieldAPer.setColumns(10);
        jTextFieldAPer.setEditable(false);
        jTextFieldAPer.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldAPer, gridBagConstraints);
*/
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelRho, gridBagConstraints);

        jTextFieldRhom.setColumns(10);
        jTextFieldRhom.setEditable(false);
        jTextFieldRhom.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldRhom, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelRhoe, gridBagConstraints);

        jTextFieldRhoe.setColumns(10);
        jTextFieldRhoe.setEditable(false);
        jTextFieldRhoe.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldRhoe, gridBagConstraints);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jLabelRhoer, gridBagConstraints);

        jTextFieldRhoer.setColumns(10);
        jTextFieldRhoer.setEditable(false);
        jTextFieldRhoer.setHorizontalAlignment(JTextField.RIGHT);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new Insets(2, 2, 2, 2);
        Sur.add(jTextFieldRhoer, gridBagConstraints);

        getContentPane().add(Sur, BorderLayout.SOUTH);

        jMenuItemG_L.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, InputEvent.ALT_MASK));
        jMenuA.add(jMenuItemG_L);
        jMenuA.add(jSeparator1);
        jMenuItemS.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.ALT_MASK));
        jMenuA.add(jMenuItemS);
        jMenuBar1.add(jMenuA);
        jMenuItemEs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.ALT_MASK));
		jMenuItemEn.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.ALT_MASK));
		jMenuItemEs.setSelected(true);
		gLenguaje.add(jMenuItemEs);
		gLenguaje.add(jMenuItemEn);
        jMenuL.add(jMenuItemEs);
		jMenuL.add(jMenuItemEn);
        jMenuBar1.add(jMenuL);
		jMenuBar1.add(jMenuA_D);
        setJMenuBar(jMenuBar1);
		
		setLanguageLabels(Lenguaje);

        pack();
		setExtendedState(Frame.MAXIMIZED_BOTH);
    }
   
    // Variables declaration
    private JButton jButtonB_AP;
    private JLabel jLabelRhoer;
    private JButton jButtonA_AP;
    private JSpinner jSpinnerFechaInicio;
	private JSpinner jSpinnerFechaFin;
	private JButton jButtonF_I;
	private JButton jButtonF_F;
    private JList jListT;
    private JButton jButtonA_T;
    private JLabel jLabelT;
    private JLabel jLabelEq;
    private JTextField jTextFieldC;
    private JLabel jLabelAPe;
    private JButton jButtonB_T;
    private JMenuItem jMenuItemG_L;
    private JTextField jTextFieldRhoer;
    private JList jListC;
    private JScrollPane jScrollPaneInstr;
    private JFileChooser fc;
    private JLabel jLabelFechaInicio;
	private JLabel jLabelFechaFin;
    private JScrollPane jScrollPaneDesc;
    private JTextField jTextFieldAPer;
    private JLabel jLabelAPer;
    private JMenu jMenuA;
	private JMenuItem jMenuA_D;
    private JTextField jTextFieldRhom;
    private JTextField jTextFieldAPe;
    private JLabel jLabelA;
	private JLabel jLabelMinDiv;
    private JLabel jLabelRho;
    private JLabel jLabelDesc;
    private JTextField jTextFieldObs;
    private JLabel jLabel12;
    private JLabel jLabelDEC;
    private JTextField jTextFieldA;
    private JTextField jTextFieldMinDiv;
    private JPanel jPanelCentro;
    private JMenuItem jMenuItemS;
    private JLabel jLabelObs;
    private JMenu jMenuL;
    private JLabel jLabelInstr;
    private JButton jButtonB_C;
    private JLabel jLabelRhoe;
    private JLabel jLabelC;
    private JList jListAP;
    private JRadioButtonMenuItem jMenuItemEs;
	private JRadioButtonMenuItem jMenuItemEn;
	private JLabel jLabelAR;
    private JSpinner jSpinnerARh;
	private JSpinner jSpinnerARm;
	private JSpinner jSpinnerARs;
	private JSpinner jSpinnerDecg;
	private JSpinner jSpinnerDecm;
	private JSpinner jSpinnerDecs;
    private JPanel Sur;
    private JButton jButtonA_C;
    private JTextField jTextFieldT;
    private JPanel jPanelNorte;
    private JTextField jTextFieldRhoe;
    private JLabel jLabel11;
    private JTextField jTextFieldAP;
    private JTextField jTextFieldEq;
    private JSeparator jSeparator1;
    private JLabel jLabelAPm;
    private JPanel jPanelAP;
    private JLabel jLabelAP;
    private JTextArea jTextAreaDesc;
    private JPanel jPanelRho;
    private JTextArea jTextAreaInstr;
    private JTextField jTextFieldAPm;
    private JMenuBar jMenuBar1;
	private PanelLogo plogo;
	private ButtonGroup gLenguaje;
	private String Lenguaje;
	private DefaultListModel lmC;
	private DefaultListModel lmAP;
	private DefaultListModel lmT;
	private JScrollPane jScrollPaneC;
	private JScrollPane jScrollPaneAP;
	private JScrollPane jScrollPaneT;
	private estadistica et;
	private double [] valores;        
	private DecimalFormat myFormatter;
	private double promedioC, errC;
	private double promedioAP, errAP, pAP;
	private double promedioT, errT;
	private double promedioRho, errRho;
	private String CuidadoEscribir;
	private final double rad = Math.PI/180.0;
	private double declinacion, AP, A;
	private JFormattedTextField ftf;
}